const state = {
    user: null,
    loadingUser: true
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    user(state) {
        return state.user
    },
    /**
     * 
     * @param {*} state 
     */
    loadingUser(state) {
        return state.loadingUser
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setUser(state, payload) {
        state.user = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setLoadingUser(state, payload) {
        state.loadingUser = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    initUser({ commit }, payload) {
        commit('setUser', payload)
        commit('setLoadingUser', false)
    },
    /**
     * 
     * @param {*} param0 
     */
    resetUser({ commit }) {
        commit('setLoadingUser', true)
        commit('setUser', null)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}